// ADOBE SYSTEMS INCORPORATED
// Copyright  1993 - 2002 Adobe Systems Incorporated
// All Rights Reserved
//
// NOTICE:  Adobe permits you to use, modify, and distribute this 
// file in accordance with the terms of the Adobe license agreement
// accompanying it.  If you have received this file from a source
// other than Adobe, then your use, modification, or distribution
// of it requires the prior written permission of Adobe.
//-------------------------------------------------------------------
/*
	File: NearestBaseUIWin.c

	C source file for Windows specific code for Color Picker example.
*/ 

#include "NearestBase.h"
#include "DialogUtilities.h"
#include <math.h>

#include "painter_picker_screen.h"
#include "painter_picker_font.h"
#include "painter_picker_bg.h"
#include "painter_picker_circle.h"
#include "painter_picker_delta.h"

/*****************************************************************************/

DLLExport BOOL WINAPI PickerProc(HWND hDlg, UINT wMsg, WPARAM wParam, LPARAM lParam); // Win32 Change

/*****************************************************************************/

void DoAbout (AboutRecordPtr about)
{
	ShowAbout(about);
}

/*****************************************************************************/


extern void PrintPixel(HWND hDlg, BYTE* pixel, int x, int y, int w, int h);
extern void PaintProxy(HWND hDlg);
extern void PrintCurrentColor(HWND hDlg);
extern double GetKakudo(int x, int y);
extern void PrintDeltazone(HWND hDlg);
extern void PrintCursorCircle(HWND hDlg);
extern void PrintCursorDelta(HWND hDlg, int x, int y);
extern double OuterProduct(double ax, double ay, double az, double bx, double by, double bz, double cx, double cy, double cz);
extern void GetHajikkoDeltaCursor( double* px, double* py);
extern int CheckHajikkoDeltaCursor(int mx, int my);
extern void DrawPixel(HWND hDlg, BYTE* pixel, int px, int py, int x, int y, int w, int h,  int rowBytes);
extern void DrawPixelM(HWND hDlg, BYTE* pixel, BYTE* mask_data, int px, int py, int x, int y, int w, int h,  int rowBytes);
extern void PrintFont(char c, int x, int y);
extern void PrintCurColor(void);
extern int bank_round(double a);


extern void _DrawPixel(HWND hDlg, BYTE* pixel, int px, int py, int x, int y, int w, int h, int rowBytes);



BYTE Delta[100*100*4];


HDC				hDC;
PAINTSTRUCT		ps;
int				mouseDown = 0;
int				sikisousentaku=0;
int				deltasentaku=0;
const double	RD=3.1415926535/180;
const int		windoww=200;
const int		windowh=230;



DLLExport BOOL WINAPI PickerProc(HWND hDlg, UINT wMsg, WPARAM wParam, LPARAM lParam) // Win32 Change
{
//	HDC hdc, hBuffer;
//	PAINTSTRUCT ps;

	int				idd;	// WIN32 Change
	static GPtr		globals=NULL;		  /* need to be static */
	long			x = 0;
	static int		inflag=0;
	int mousex =0;
	int mousey =0;
	POINT curpoint;
	static HICON hIcon;



	switch (wMsg)
	{
		case WM_DESTROY:
			break;

		case WM_CREATE:
			break;

		case  WM_INITDIALOG:
			/* set up globals	*/
			globals = (GPtr) lParam;
			
			GetCursorPos(&curpoint);
			//			SetWindowPos(hDlg, NULL, curpoint.x-windoww/2, curpoint.y-windowh/2, windoww, windowh, SWP_NOZORDER);
			{
				int wposx=curpoint.x-windoww/2;
				int wposy=curpoint.y-windowh/2;
//				int sysw=GetSystemMetrics(SM_CXSCREEN)-windoww;
//				int sysh=GetSystemMetrics(SM_CYSCREEN)-windowh;
				int sys_l=GetSystemMetrics(SM_CXSCREEN) - GetSystemMetrics(SM_CXFULLSCREEN);
				int sys_r=GetSystemMetrics(SM_CXFULLSCREEN)-windoww;
				int sys_t=GetSystemMetrics(SM_CYSCREEN) - GetSystemMetrics(SM_CYFULLSCREEN);
				int sys_d=GetSystemMetrics(SM_CYFULLSCREEN)-windowh;

				if(wposx<sys_l){
					wposx=sys_l;
				}
				else if(wposx>=sys_r){
					wposx=sys_r;
				}

				if(wposy<sys_t){
					wposy=sys_t;
				}
				else if(wposy>=sys_d){
					wposy=sys_d;
				}

				SetWindowPos(hDlg, NULL, wposx, wposy, windoww, windowh, SWP_NOZORDER);
			}

			/* fall into WM_PAINT */
		case WM_PAINT:
			{
				uint8* pB = (uint8*)proxyBuffer;
				for(int i=0;i<300*300*4; i++){pB[i]=0;}

				hDC = BeginPaint(hDlg, &ps);	
				PaintProxy(hDlg);
			}

			PrintCurColor();
			// XN[̃tbV
			_DrawPixel(hDlg, painter_picker_screen, 0, 0, 0, 0, 192, 222, 192*3);


			return TRUE;
			break;

		case WM_KILLFOCUS:
			break;

		case WM_LBUTTONUP:
			mouseDown=0;
			sikisousentaku=0;
			deltasentaku=0;
			break;

		case WM_LBUTTONDOWN:
			if(mouseDown==0){		// ŏ̃_ȄuԂ
				hensyuu=1;

				mousex= (int)LOWORD(lParam);
				mousey= (int)HIWORD(lParam);
				mousex-=circleCx;
				mousey-=circleCy;
				double r = sqrt((double)((mousex*mousex)+(mousey*mousey)));
				if(r>63&&r<82){
					sikisousentaku=1; //FI
					
					cursikisou = GetKakudo(mousex,mousey);
					
//					PrintDeltazone();

					PrintCurColor();
					// XN[̃tbV
					_DrawPixel(hDlg, painter_picker_screen, 0, 0, 0, 0, 192, 222, 192*3);
				}


				mousex= (int)LOWORD(lParam);
				mousey= (int)HIWORD(lParam);
				if(CheckHajikkoDeltaCursor(mousex,mousey)==1){
					deltasentaku=1;
					PrintCursorDelta(hDlg, mousex, mousey);
					PrintCurrentColor(hDlg);
					PrintCursorCircle(hDlg);

					PrintCurColor();
					// XN[̃tbV
					_DrawPixel(hDlg, painter_picker_screen, 0, 0, 0, 0, 192, 222, 192*3);

				}
			}

			mouseDown=1;
			break;

		case WM_MOUSEMOVE:
			if(deltasentaku==1) {
				mousex= (int)LOWORD(lParam);
				mousey= (int)HIWORD(lParam);

//				PrintDeltazone();

				if(CheckHajikkoDeltaCursor(mousex,mousey)==0){
					double hajikkox=(double)mousex;
					double hajikkoy=(double)mousey;
					GetHajikkoDeltaCursor( &hajikkox, &hajikkoy);
					PrintCursorDelta(hDlg, (int)hajikkox, (int)hajikkoy);
					PrintCursorCircle(hDlg);
				}
				else{
					PrintCursorDelta(hDlg, mousex, mousey);
					PrintCurrentColor(hDlg);
					PrintCursorCircle(hDlg);
				}
	
				PrintCurColor();
				// XN[̃tbV
				_DrawPixel(hDlg, painter_picker_screen, 0, 0, 0, 0, 192, 222, 192*3);
			}

			
			
			if(sikisousentaku==1){
				mousex= (int)LOWORD(lParam);
				mousey= (int)HIWORD(lParam);
				mousex-=circleCx;
				mousey-=circleCy;
				cursikisou = GetKakudo(mousex,mousey);

//				PrintDeltazone();
				PrintCursorDelta(hDlg, deltacursorx,deltacursory);

				PrintCursorCircle(hDlg);

				PrintCurColor();
				// XN[̃tbV
				_DrawPixel(hDlg, painter_picker_screen, 0, 0, 0, 0, 192, 222, 192*3);

			}


			switch(inflag){
				case 0:
					mousex= LOWORD(lParam);
					mousey= HIWORD(lParam);
					if(mousex>0&&mousex<windoww&&mousey>0&&mousey<windowh){
						inflag=1;
						SetCapture(hDlg);
					}
					break;
				
				case 1:
					 mousex= LOWORD(lParam);
					 mousey= HIWORD(lParam);
					if((mousex<0||mousex>windoww||mousey<0||mousey>windowh)){
						ReleaseCapture();
						EndPaint(hDlg, (LPPAINTSTRUCT) &ps);

						idd=OK;
//						wMsg=WM_COMMAND;
//						wParam=OK;
//						gResult = userCanceledErr;
						EndDialog(hDlg, idd);          // WIN32 change
					}
					break;
			}
			break;

		case WM_COMMAND:
	  		idd = COMMANDID (wParam);              // WIN32 Change
			if (idd == x) // any radio groups
				; // handle radios;
			else
			{
				switch (idd)
				{
					case OK:
						// assign to globals
						EndDialog(hDlg, idd);
						break;
					case CANCEL:
						gResult = userCanceledErr;
						EndDialog(hDlg, idd);          // WIN32 change
						break;
					default:
						return FALSE;
						break;
				}
			}
			break;
		default:
			return FALSE;
			break;
	}
	return TRUE;
}



void PrintFont(char c, int x, int y)
{
	int		px;
	int		py;

	switch(c){
	case '0':	px=0x00;	py=0;	break;
	case '1':	px=0x08;	py=0;	break;
	case '2':	px=0x10;	py=0;	break;
	case '3':	px=0x18;	py=0;	break;
	case '4':	px=0x20;	py=0;	break;
	case '5':	px=0x28;	py=0;	break;
	case '6':	px=0x30;	py=0;	break;
	case '7':	px=0x38;	py=0;	break;
	case '8':	px=0x40;	py=0;	break;
	case '9':	px=0x48;	py=0;	break;

	case 'r': case 'R':		px=0x00;	py=0x08;	break;
	case 'g': case 'G':		px=0x08;	py=0x08;	break;
	case 'b': case 'B':		px=0x10;	py=0x08;	break;
	case 'h': case 'H':		px=0x18;	py=0x08;	break;
	case 's': case 'S':		px=0x20;	py=0x08;	break;
	case 'v': case 'V':		px=0x28;	py=0x08;	break;
	case '%':				px=0x30;	py=0x08;	break;
	case ':':				px=0x38;	py=0x08;	break;
/*
	case '!':	px=0x88;	py=0;	break;
	case '"':	px=0x90;	py=0;	break;
	case '#':	px=0x98;	py=0;	break;
	case '$':	px=0xa0;	py=0;	break;
	case '%':	px=0xa8;	py=0;	break;
	case '&':	px=0xb0;	py=0;	break;
	case '\'':	px=0xb8;	py=0;	break;
	case '(':	px=0xc0;	py=0;	break;
	case ')':	px=0xc8;	py=0;	break;
	case '*':	px=0xd0;	py=0;	break;
	case '+':	px=0xd8;	py=0;	break;

	case ',':	px=0x00;	py=0x08;	break;
	case '-':	px=0x08;	py=0x08;	break;
	case '.':	px=0x10;	py=0x08;	break;
	case '/':	px=0x18;	py=0x08;	break;

	case ':':	px=0x70;	py=0x08;	break;
	case ';':	px=0x78;	py=0x08;	break;
	case '<':	px=0x80;	py=0x08;	break;
	case '=':	px=0x88;	py=0x08;	break;
	case '>':	px=0x90;	py=0x08;	break;
	case '?':	px=0x98;	py=0x08;	break;
	case ' ':	px=0xa0;	py=0x08;	break;

	case 'a':	px=0xa8;	py=0x08;	break;
	case 'b':	px=0xb0;	py=0x08;	break;
	case 'c':	px=0xb8;	py=0x08;	break;
	case 'd':	px=0xc0;	py=0x08;	break;
	case 'e':	px=0xc8;	py=0x08;	break;
	case 'f':	px=0xd0;	py=0x08;	break;
	case 'g':	px=0xd8;	py=0x08;	break;
	case 'h':	px=0x00;	py=0x10;	break;
	case 'i':	px=0x08;	py=0x10;	break;
	case 'j':	px=0x10;	py=0x10;	break;
	case 'k':	px=0x18;	py=0x10;	break;
	case 'l':	px=0x20;	py=0x10;	break;
	case 'm':	px=0x28;	py=0x10;	break;
	case 'n':	px=0x30;	py=0x10;	break;
	case 'o':	px=0x38;	py=0x10;	break;
	case 'p':	px=0x40;	py=0x10;	break;
	case 'q':	px=0x48;	py=0x10;	break;
	case 'r':	px=0x50;	py=0x10;	break;
	case 's':	px=0x58;	py=0x10;	break;
	case 't':	px=0x60;	py=0x10;	break;
	case 'u':	px=0x68;	py=0x10;	break;
	case 'v':	px=0x70;	py=0x10;	break;
	case 'w':	px=0x78;	py=0x10;	break;
	case 'x':	px=0x80;	py=0x10;	break;
	case 'y':	px=0x88;	py=0x10;	break;
	case 'z':	px=0x90;	py=0x10;	break;

	case '@':	px=0x98;	py=0x10;	break;
	case '~':	px=0xa0;	py=0x10;	break;
*/	default:	px=0;		py=0;		break;
	}


	BYTE*	s = painter_picker_screen;
	BYTE*	f = painter_picker_font;
	for(int j=0;j<8;j++){
		for(int i=0;i<8;i++){
			s[((y+j)*192*3) + ((x+i)*3) + 0] = f[((py+j)*80*3) + ((px+i)*3) + 0];
			s[((y+j)*192*3) + ((x+i)*3) + 1] = f[((py+j)*80*3) + ((px+i)*3) + 1];
			s[((y+j)*192*3) + ((x+i)*3) + 2] = f[((py+j)*80*3) + ((px+i)*3) + 2];
		}
	}
}



void PrintIntFont(int a, int x, int y)
{
	if(a>=10 || a <0){
		PrintFont(' ', x, y);
	}
	else {
		switch(a){
		case 0:		PrintFont('0', x, y);	break;
		case 1:		PrintFont('1', x, y);	break;
		case 2:		PrintFont('2', x, y);	break;
		case 3:		PrintFont('3', x, y);	break;
		case 4:		PrintFont('4', x, y);	break;
		case 5:		PrintFont('5', x, y);	break;
		case 6:		PrintFont('6', x, y);	break;
		case 7:		PrintFont('7', x, y);	break;
		case 8:		PrintFont('8', x, y);	break;
		case 9:		PrintFont('9', x, y);	break;
		}
	}
}



void PrintCurColor()
{
	int curcolor_font_mode=1;

	int ofsx=136;
	int ofsy=8;

	switch(curcolor_font_mode) {
		case 0:
		{
			int r=curcolor[0];	int r0,r1,r2;
			int g=curcolor[1];	int g0,g1,g2;
			int b=curcolor[2];	int b0,b1,b2;

			r0=r%10;
			r1=(r%100)-r0;	r1/=10;
			r2=r-(r%100);	r2/=100;

			g0=g%10;
			g1=(g%100)-r0;	g1/=10;
			g2=g-(g%100);	g2/=100;

			b0=b%10;
			b1=(b%100)-r0;	b1/=10;
			b2=b-(b%100);	b2/=100;

			PrintFont('r',ofsx+0, ofsy+0);
			PrintIntFont( r2,ofsx+16, ofsy+0);
			PrintIntFont( r1,ofsx+24, ofsy+0);
			PrintIntFont( r0,ofsx+32, ofsy+0);

			PrintFont('g',ofsx+0, ofsy+10);
			PrintIntFont( g2,ofsx+16, ofsy+10);
			PrintIntFont( g1,ofsx+24, ofsy+10);
			PrintIntFont( g0,ofsx+32, ofsy+10);

			PrintFont('b',ofsx+0, ofsy+20);
			PrintIntFont( b2,ofsx+16, ofsy+20);
			PrintIntFont( b1,ofsx+24, ofsy+20);
			PrintIntFont( b0,ofsx+32, ofsy+20);
		}
		break;

		case 1:
		{
			double	r=(double)curcolor[0];
			double	g=(double)curcolor[1];
			double	b=(double)curcolor[2];
			double	h, s, v;
			double	max,mid,min;
			int		feeld;
			int		bitlength=0xFF;

			if(r>=g&&r>=b){
				if(g>=b){
					max=r; mid=g; min=b;
					feeld=0;
				}
				else {
					max=r; mid=b; min=g;
					feeld=0;
				}
			}
			else if(g>=b&&g>=r){
				if(b>=r){
					max=g; mid=b; min=r;
					feeld=1;
				}
				else {
					max=g; mid=r; min=b;
					feeld=1;
				}
			}
			else if(b>=r&&b>=g){
				if(r>=g){
					max=b; mid=r; min=g;
					feeld=2;
				}
				else {
					max=b; mid=g; min=r;
					feeld=2;
				}
			}

			RGB2HSB( max, mid, min, r,g,b, &h, &s, &v, bitlength, feeld);


			int h0,h1,h2;
			int s0,s1,s2;
			int v0,v1,v2;
			int ih=(int)bank_round(h);			ih=(ih+360)%360;
			int is=(int)bank_round((1-s)*100);
			int iv=(int)bank_round(v*100);

			h0=ih%10;
			h1=(ih%100)-h0;	h1/=10;
			h2=ih-(ih%100);	h2/=100;

			s0=is%10;
			s1=(is%100)-s0;	s1/=10;
			s2=is-(is%100);	s2/=100;

			v0=iv%10;
			v1=(iv%100)-v0;	v1/=10;
			v2=iv-(iv%100);	v2/=100;

			PrintFont('h',ofsx+0, ofsy+0);
			PrintIntFont( h2,ofsx+16, ofsy+0);
			PrintIntFont( h1,ofsx+24, ofsy+0);
			PrintIntFont( h0,ofsx+32, ofsy+0);
//			PrintFont('%',ofsx+40, ofsy+0);

			PrintFont('s',ofsx+0, ofsy+10);
			PrintIntFont( s2,ofsx+16, ofsy+10);
			PrintIntFont( s1,ofsx+24, ofsy+10);
			PrintIntFont( s0,ofsx+32, ofsy+10);
			PrintFont('%',ofsx+40, ofsy+10);

			PrintFont('v',ofsx+0, ofsy+20);
			PrintIntFont( v2,ofsx+16, ofsy+20);
			PrintIntFont( v1,ofsx+24, ofsy+20);
			PrintIntFont( v0,ofsx+32, ofsy+20);
			PrintFont('%',ofsx+40, ofsy+20);
		}
		break;
	}
}



int CheckHajikkoDeltaCursor(int mousex, int mousey)
{
	const double	p1x=59;
	const double	p1y=69;
	const double	p1z=0;
	const double	p2x=159;
	const double	p2y=119;
	const double	p2z=0;
	const double	p3x=59;
	const double	p3y=169;
	const double	p3z=0;
	double			ret1, ret2, ret3;
	int				cursor_delta_in;

	ret1=OuterProduct(p1x,p1y,p1z,(double)mousex,(double)mousey,0,p2x,p2y,p2z);
	ret2=OuterProduct(p2x,p2y,p2z,(double)mousex,(double)mousey,0,p3x,p3y,p3z);
	ret3=OuterProduct(p3x,p3y,p3z,(double)mousex,(double)mousey,0,p1x,p1y,p1z);

	if(   ( (ret1>=0) && (ret2>=0) && (ret3>=0) )   ||   ( (ret1<0) && (ret2<0) && (ret3<0) )   ) {
		cursor_delta_in=1;
	}
	else {
		cursor_delta_in=0;
	}

	return cursor_delta_in;
}



void GetHajikkoDeltaCursor( double* px, double* py)
{
	const double	p1x=59;
	const double	p1y=69;
	const double	p2x=159;
	const double	p2y=119;
	const double	p3x=59;
	const double	p3y=169;
	const double	R=27*RD;

	int				ryouiki;
	double x = *px;
	double y = *py;

	if(x<=p1x){
		ryouiki=0;
	}
	else if(y<=p2y){
		ryouiki=1;
	}
	else if(y>p2y){
		ryouiki=2;
	}
	else{
		ryouiki=-1;
	}


	if(ryouiki==0){
		x = p1x;
		if(y<=p1y){
			y=p1y;
		}
		else if(y>=p3y){
			y=p3y;
		}
	}
	else if(ryouiki==1){
		x=x-p1x;
		y=y-p1y;

		double nx,ny;
		nx = x*cos(R) + y*sin(R);
		ny = -x*sin(R) + y*cos(R);
		
		ny=0;
		x=nx; y=ny;
		nx = x*cos(-R) + y*sin(-R);
		ny = -x*sin(-R) + y*cos(-R);

		x=nx+p1x;
		y=ny+p1y;

		if(x<p1x){x=p1x; y=p1y;}else if(x>p2x){x=p2x; y=p2y;}
	}
	else if(ryouiki==2){
		x=x-p3x;
		y=y-p3y;

		double nx,ny;
		nx = x*cos(-R) + y*sin(-R);
		ny = -x*sin(-R) + y*cos(-R);
		
		ny=1;
		x=nx; y=ny;
		nx = x*cos(R) + y*sin(R);
		ny = -x*sin(R) + y*cos(R);

		x=nx+p3x;
		y=ny+p3y;

		if(x<p1x){x=p3x; y=p3y;}else if(x>p2x){x=p2x; y=p2y;}
	}


	*px = x;
	*py = y;
}




double OuterProduct(
	double ax, double ay, double az,
	double bx, double by, double bz,
	double cx, double cy, double cz
) {
	double Ax=bx-ax;
	double Ay=by-ay;
	double Az=bz-az;

	double Bx=cx-bx;
	double By=cy-by;
	double Bz=cz-bz;

	double opx = (Ay*Bz-Az*By);
	double opy = (Az*Bx-Ax*Bz);
	double opz = (Ax*By-Ay*Bx);

	return opz;
}



double GetKakudo(int x, int y)
{
	double dx =(double)x;
	double dy =(double)y;
	double a;
	double r = sqrt(dx*dx+dy*dy);
	if(r<0.0000001){r=0.0000001;}

	if(x>=0){
		if(y>=0){
//			printf("a");
			a=acos(dx/r);
			if(a!=0){return(a/RD);}
			else{return(0);}
		}
		else {
//			printf("b");
			a=acos(dx/r);
			if(a!=0){return(360-(a/RD));}
			else{return(360);}
		}
	}
	else {
		if(y>=0){
//			printf("c");
			dx=-dx;
			a=acos(dx/r);
			if(a!=0){return(180-(a/RD));}
			else{return(180);}
		}
		else {
//			printf("d");
			dx=-dx;
			a=acos(dx/r);
			if(a!=0){return(180+(a/RD));}
			else{return(270);}
		}
	}
	return(0);
}



void PaintProxy(HWND hDlg)
{
	PrintPixel(hDlg, painter_picker_bg, 0, 0, 192, 222);
}


void PrintDeltazone(HWND hDlg)
{
	double hr,hg,hb;
	double rz;
	double sikisou = (double)(((int)cursikisou+90+45)%360);

	if(sikisou>=0&&sikisou<60){
		rz=(sikisou-0)/60;
		hr=1; hg=rz; hb=0;
	}
	else if(sikisou>=60&&sikisou<120){
		rz=(sikisou-60)/60;
		hr=1-rz; hg=1; hb=0;
	}
	else if(sikisou>=120&&sikisou<180){
		rz=(sikisou-120)/60;
		hr=0; hg=1; hb=rz;
	}
	else if(sikisou>=180&&sikisou<240){
		rz=(sikisou-180)/60;
		hr=0; hg=1-rz; hb=1;
	}
	else if(sikisou>=240&&sikisou<300){
		rz=(sikisou-240)/60;
		hr=rz; hg=0; hb=1;
	}
	else if(sikisou>=300){
		rz=(sikisou-300)/60;
		hr=1; hg=0; hb=1-rz;
	}


	BYTE* delta = Delta;
	int curw=100;
	int curh=100;
	for(int j=0; j<100; j++){
		curh=curw;
		for(int i=0; i<100; i++){
			if(i<curw){
				double v = 1-((double)j/ 100);
				double s = 1-((double)i/ (double)curw);

				double r,g,b;
				r = (hr + (1-hr)*s) * v;
				g = (hg + (1-hg)*s) * v;
				b = (hb + (1-hb)*s) * v;

				const int rgb_bit =0xFF;
				delta[0] = (BYTE)(r * rgb_bit);
				delta[1] = (BYTE)(g * rgb_bit);
				delta[2] = (BYTE)(b * rgb_bit);
			}
			delta+=3;
			curh--;
		}
		curw--;
	}


	{
		// f^`̏iځj
		BYTE*		delta=Delta;
		BYTE		delta_color[200*200*4];
		BYTE*		ptr_delta_color = delta_color;
		for(int j=0;j<100;j++){
			for(int i=0;i<100;i++){
				ptr_delta_color[ ((j+(i/2))*100*3) + (i*3)+0] = delta[(j*100*3)+(i*3)+0];
				ptr_delta_color[ ((j+(i/2))*100*3) + (i*3)+1] = delta[(j*100*3)+(i*3)+1];
				ptr_delta_color[ ((j+(i/2))*100*3) + (i*3)+2] = delta[(j*100*3)+(i*3)+2];
			}
		}

		// BG`̏
		const int ofsx = circleCx - 37;
		const int ofsy = circleCy - 50;

		BYTE*		bgp=painter_picker_bg;
		BYTE		bg_color[200*200*4];
		BYTE*		ptr_bg_color = bg_color;
		for(int j=0;j<100;j++){
			for(int i=0;i<100;i++){
				ptr_bg_color[0]=bgp[((ofsy+j)*192*3)+((ofsx+i)*3) +0];
				ptr_bg_color[1]=bgp[((ofsy+j)*192*3)+((ofsx+i)*3) +1];
				ptr_bg_color[2]=bgp[((ofsy+j)*192*3)+((ofsx+i)*3) +2];
				ptr_bg_color+=3;
			}
		}

		// }XN`̏
		BYTE		mask_color[200*200*4];
		BYTE*		ptr_mask_color = mask_color;
		int			curw=0;
		for(int j=0;j<50;j++){
			for(int i=0;i<100;i++){
				if(i>curw){
					ptr_mask_color[0] = ptr_mask_color[1] = ptr_mask_color[2] = 0;
				}
				else {
					ptr_mask_color[0] = ptr_mask_color[1] = ptr_mask_color[2] = 255;
				}
				ptr_mask_color+=3;
			}
			curw+=2;
		}
		curw=98;
		for(int j=50;j<100;j++){
			for(int i=0;i<100;i++){
				if(i>curw){
					ptr_mask_color[0] = ptr_mask_color[1] = ptr_mask_color[2] = 0;
				}
				else {
					ptr_mask_color[0] = ptr_mask_color[1] = ptr_mask_color[2] = 255;
				}
				ptr_mask_color+=3;
			}
			curw-=2;
		}

		// f^BG}XNɂč
		BYTE		mix_color[200*200*4];
		BYTE*		ptr_mix_color = mix_color;

		ptr_bg_color	= bg_color;
		ptr_delta_color	= delta_color;
		ptr_mask_color	= mask_color;

		for(int j=0;j<100;j++){
			for(int i=0;i<100;i++){
				if(ptr_mask_color[0]==0) {
					ptr_mix_color[0] = ptr_bg_color[0];
					ptr_mix_color[1] = ptr_bg_color[1];
					ptr_mix_color[2] = ptr_bg_color[2];
				}
				else {
					ptr_mix_color[0] = ptr_delta_color[0];
					ptr_mix_color[1] = ptr_delta_color[1];
					ptr_mix_color[2] = ptr_delta_color[2];
				}

				ptr_bg_color	+=3;
				ptr_delta_color	+=3;
				ptr_mask_color	+=3;
				ptr_mix_color	+=3;
			}
		}

		
		// Ƃt݂iw
		DrawPixel(hDlg, mix_color, ofsy, ofsx, 0,0,100,100, 100*3);
	}
/*
	delta = Delta;
	curw=100;
	curh=100;
	const int ofsx = circleCx - 37;
	const int ofsy = circleCy - 50;

	for(int j=0; j<100; j++){
		curh=curw;
		for(int i=0; i<curw; i++){
			SetPixelV( hDC, i+ofsx, j+ofsy+i/2, RGB(delta[0], delta[1], delta[2]) );
			delta+=3;
			curh--;
		}
		curw--;
	}
*/
}




void PrintCurrentColor(HWND hDlg)
{
	// JgJ[
	BYTE	buf_color[50*50*4];
	BYTE*	ptr_buf_color = buf_color;
	for(int j=0; j<50; j++){
		for(int i=0; i<50; i++){
			ptr_buf_color[0]=curcolor[0];
			ptr_buf_color[1]=curcolor[1];
			ptr_buf_color[2]=curcolor[2];
			ptr_buf_color+=3;
		}
	}

	DrawPixel(hDlg, buf_color, 209, 132, 0,0,40,11,  50*3);
	DrawPixel(hDlg, buf_color, 5, 25, 0,0,43,25,  50*3);
}




void PrintCursorCircle(HWND hDlg)
{
	static int	oldx=0;
	static int	oldy=0;

	BYTE*		p = painter_picker_circle;
	const int	w = 12;
	const int	h = 12;
	const int	r = 74;
	const int	ofsx = -5;
	const int	ofsy = -6;



	{
		BYTE*		bgp=painter_picker_bg;
		BYTE		buf_color[20*20*4];
		BYTE*		ptr_buf_color = buf_color;
		for(int j=0;j<12;j++){
			for(int i=0;i<12;i++){
				ptr_buf_color[0]=bgp[ (oldy*192*3)+(j*192*3)+(oldx*3)+(i*3)+0];
				ptr_buf_color[1]=bgp[ (oldy*192*3)+(j*192*3)+(oldx*3)+(i*3)+1];
				ptr_buf_color[2]=bgp[ (oldy*192*3)+(j*192*3)+(oldx*3)+(i*3)+2];
				ptr_buf_color+=3;
			}
		}
		// Ƃt݂iw
		DrawPixel(hDlg, buf_color, oldy, oldx, 0,0,12,12, 12*3);
	}



	double		sikisou = cursikisou;
//	double		sikisou = (int)(cursikisou+90+45)%360;
	int			x;
	int			y;

	x = (int)(r*cos(sikisou*RD) + 0*sin(sikisou*RD)); 
	y = (int)(r*sin(sikisou*RD) - 0*cos(sikisou*RD));
	
	x+=circleCx+ofsx;
	y+=circleCy+ofsy;

	{
		BYTE*		s = painter_picker_screen;
		for( int j=0;j<h;j++){
			for( int i=0;i<w;i++){
				if((p[0]==0xFF)&&(p[2]==0xFF)) {
				}
				else {
					s[ ((y+j)*192*3) + ((x+i)*3) + +0] = p[0];
					s[ ((y+j)*192*3) + ((x+i)*3) + +1] = p[1];
					s[ ((y+j)*192*3) + ((x+i)*3) + +2] = p[2];
				}

				p+=3;
			}
		}
	}

	oldx=x;
	oldy=y;
}



int bank_round(double a)
{
	int r=(int)a;

	if(a>0){
		if( ( ((int)(a+0.5)) & 0x01 ) == 0 ){
//			r=(int)(a+0.0);		// sۂ
			r=(int)(a+0.5);		// ʂ̎ľܓ
		}
		else {
			r=(int)(a+0.5);
		}
	}
	else if(a<0){
		// }CiX̏ꍇ
	}

	return r;
}



void PrintCursorDelta(HWND hDlg, int x, int y)
{
	static int	oldx=0;
	static int	oldy=0;

	double	cx = deltacursorx = x;
	double	cy = deltacursory = y;



	BYTE*		p = painter_picker_delta;
	const int	w = 12;
	const int	h = 12;
	const int	ofsx = -5;
	const int	ofsy = -6;

	{
		BYTE*		bgp=painter_picker_bg;
		BYTE		buf_color[20*20*4];
		BYTE*		ptr_buf_color = buf_color;
		for(int j=0;j<12;j++){
			for(int i=0;i<12;i++){
				ptr_buf_color[0]=bgp[ (oldy*192*3)+(j*192*3)+(oldx*3)+(i*3)+0];
				ptr_buf_color[1]=bgp[ (oldy*192*3)+(j*192*3)+(oldx*3)+(i*3)+1];
				ptr_buf_color[2]=bgp[ (oldy*192*3)+(j*192*3)+(oldx*3)+(i*3)+2];
				ptr_buf_color+=3;
			}
		}
		// Ƃt݂iw
		DrawPixel(hDlg, buf_color, oldy, oldx, 0,0,12,12, 12*3);
	}


	
	PrintDeltazone(hDlg);




	x+=ofsx;
	y+=ofsy;

	{
		BYTE*		s = painter_picker_screen;
		for( int j=0;j<h;j++){
			for( int i=0;i<w;i++){
				if((p[0]==0xFF)&&(p[2]==0xFF)) {
				}
				else {
					s[ ((y+j)*192*3) + ((x+i)*3) + +0] = p[0];
					s[ ((y+j)*192*3) + ((x+i)*3) + +1] = p[1];
					s[ ((y+j)*192*3) + ((x+i)*3) + +2] = p[2];
				}

				p+=3;
			}
		}
	}
/*
	for( int j=0;j<h;j++){
		for( int i=0;i<w;i++){
			if((p[0]==0xFF)&&(p[2]==0xFF)) {
			}
			else {
				SetPixelV( hDC, x+i, y+j, RGB(p[2],p[1],p[0]) );
			}
			p+=3;
		}
	}
*/
	oldx=x;
	oldy=y;




	// WHSBRGB
	{
		double r=0;
		double g=0;
		double b=0;
		double h = (double)(((int)(cursikisou+90+45))%360);
//		double h = cursikisou;
		double s;
		double v;
		
		if(h>=0&&h<60){
			r=1;
			g=(h-0)/60;
			b=0;
		}
		else if(h>=60&&h<120){
			r=1-((h-60)/60);
			g=1;
			b=0;
		}
		else if(h>=120&&h<180){
			r=0;
			g=1;
			b=(h-120)/60;
		}
		else if(h>=180&&h<240){
			r=0;
			g=1-((h-180)/60);
			b=1;
		}
		else if(h>=240&&h<300){
			b=1;
			r=(h-240)/60;
			g=0;
		}
		else if(h>=300){
			b=1-((h-300)/60);
			r=1;
			g=0;
		}

		int		ofsx = 59;
		int		ofsy = 69;
		cx=cx-ofsx;
		cy=cy-ofsy;
		cy=cy-(cx/2);  // pOp`

		s=cx/(100-cy);	s=1-s; //if(s<0.001||s>1){s=1;}
		v=cy/100;		v=1-v; //if(v<0.001||v>1){v=0;}
//		v=cy/(100-cx);	//v=1-v; //if(v<0.001||v>1){v=0;}

		r=(r+ ( (1-r) *s) )*v;
		g=(g+ ( (1-g) *s) )*v;
		b=(b+ ( (1-b) *s) )*v;

		if(r<0)r=0;else if(r>1)r=1;
		if(g<0)g=0;else if(g>1)g=1;
		if(b<0)b=0;else if(b>1)b=1;

/*		char txt[100];
		itoa((int)(r*100),txt,10);
		TextOut(hDC,80,10,TEXT(txt),10);
		itoa((int)(g*100),txt,10);
		TextOut(hDC,80,30,TEXT(txt),10);
		itoa((int)(b*100),txt,10);
		TextOut(hDC,80,50,TEXT(txt),10);
*/
/*		curcolor[0]=(BYTE)(r*0xFF);
		curcolor[1]=(BYTE)(g*0xFF);
		curcolor[2]=(BYTE)(b*0xFF);
*/
/*		curcolor[0]=(BYTE)(r*0xFF+0.5); //+0.5Ă班؂̂āiľܓj
		curcolor[1]=(BYTE)(g*0xFF+0.5);
		curcolor[2]=(BYTE)(b*0xFF+0.5);
*/
		curcolor[0]=(BYTE)bank_round(r*0xFF); //݌v덷ŏ@
		curcolor[1]=(BYTE)bank_round(g*0xFF);
		curcolor[2]=(BYTE)bank_round(b*0xFF);

/*		char txt[100];
		itoa((int)(s*100),txt,10);
		TextOut(hDC,80,10,TEXT(txt),10);
		itoa((int)(v*100),txt,10);
		TextOut(hDC,80,30,TEXT(txt),10);
		itoa((int)(fastcolor[2]),txt,10);
		TextOut(hDC,80,50,TEXT(txt),10);
		itoa((int)(cursikisou),txt,10);
		TextOut(hDC,80,70,TEXT(txt),10);
*/


		if(hensyuu==0){
			curcolor[0]=fastcolor[0];
			curcolor[1]=fastcolor[1];
			curcolor[2]=fastcolor[2];
		}
		PrintCurrentColor(hDlg);
	}

}



// }XN̓삪]ł̂ƈႤBxɉāẢ̉摜\̂]łAۂ͈Ⴄ炵BPɊiq\邾BӖ
void DrawPixelM(HWND hDlg, BYTE* pixel, BYTE* mask_data, int px, int py, int x, int y, int w, int h, int rowBytes)
{
	BYTE*		p = pixel;
	PSPixelMap	pixels;
	PSPixelMask mask;


	pixels.version = 1;
	pixels.bounds.left = x;
	pixels.bounds.top = y;
	pixels.bounds.right = x+w;
	pixels.bounds.bottom = y+h;
	pixels.imageMode = plugInModeRGBColor;
//	pixels.rowBytes = w*3;
	pixels.rowBytes = rowBytes;
	pixels.colBytes = 3;
	pixels.planeBytes = 1;
	pixels.baseAddr = p;

	pixels.mat = NULL;
	pixels.masks = NULL;
	pixels.maskPhaseRow = rowBytes;
	pixels.maskPhaseCol = 3;

	mask.next = NULL;
	mask.maskData = mask_data;
	mask.rowBytes = rowBytes;
	mask.colBytes = 3;
	mask.maskDescription = kSimplePSMask;
	
	pixels.masks = &mask;
	
	(globals->pickerParamBlock->displayPixels)(&pixels, &pixels.bounds, px, py, (void*)hDC);
}




void DrawPixel(HWND hDlg, BYTE* pixel, int py, int px, int x, int y, int w, int h, int rowBytes)
{
	BYTE*		p = pixel;
	BYTE*		s = painter_picker_screen;

	for(int j=0; j<h; j++){
		for(int i=0; i<w; i++){
			s[((py+j)*192*3) + ((px+i)*3) +0] = p[((y+j)*w*3) + ((x+i)*3) +0];
			s[((py+j)*192*3) + ((px+i)*3) +1] = p[((y+j)*w*3) + ((x+i)*3) +1];
			s[((py+j)*192*3) + ((px+i)*3) +2] = p[((y+j)*w*3) + ((x+i)*3) +2];
		}
	}

//	_DrawPixel(hDlg, painter_picker_screen, 0, 0, 0, 0, 192, 222, 192*3);
}




void _DrawPixel(HWND hDlg, BYTE* pixel, int px, int py, int x, int y, int w, int h, int rowBytes)
{
	BYTE*		p = pixel;
	PSPixelMap	pixels;

	pixels.version = 1;
	pixels.bounds.left = x;
	pixels.bounds.top = y;
	pixels.bounds.right = x+w;
	pixels.bounds.bottom = y+h;
	pixels.imageMode = plugInModeRGBColor;
//	pixels.rowBytes = w*3;
	pixels.rowBytes = rowBytes;
	pixels.colBytes = 3;
	pixels.planeBytes = 1;
	pixels.baseAddr = p;

	pixels.mat = NULL;
	pixels.masks = NULL;
	pixels.maskPhaseRow = 0;
	pixels.maskPhaseCol = 0;

	(globals->pickerParamBlock->displayPixels)(&pixels, &pixels.bounds, px, py, (void*)hDC);
}





void PrintPixel(HWND hDlg, BYTE* pixel, int x, int y, int w, int h)
{
	DrawPixel(hDlg, pixel, 0,0, x, y, w, h,  w*3);



	// ̃J[
	BYTE	motono_color[50*50*4];
	BYTE*	ptr_motono_color = motono_color;
	for(int j=0; j<50; j++){
		for(int i=0; i<50; i++){
			ptr_motono_color[0]=fastcolor[0];
			ptr_motono_color[1]=fastcolor[1];
			ptr_motono_color[2]=fastcolor[2];
			ptr_motono_color+=3;
		}
	}
	DrawPixel(hDlg, motono_color, 16, 7, 0,0,18,23,  50*3);
	DrawPixel(hDlg, motono_color, 30, 25, 0,0,23,9,  50*3);


	PrintCurrentColor(hDlg);



	{
		int x=deltacursorx;
		int y=deltacursory;
		PrintCursorDelta(hDlg, x,y);
	}

	PrintCursorCircle(hDlg);
}

/*
void PrintPixel(HWND hDlg, BYTE* pixel, int x, int y, int w, int h)
{
	BYTE* p = pixel;



	// BG
	for( int j=0;j<h;j++){
		for( int i=0;i<w;i++){
			SetPixelV( hDC, x+i, y+j, RGB(p[2],p[1],p[0]) );
			p+=3;
		}
	}




	// ̃J[
	for( int j=16;j<=38;j++){
		for( int i=7;i<=24;i++){
			SetPixelV( hDC, i, j, RGB(fastcolor[0],fastcolor[1],fastcolor[2]) );
		}
	}
	for( int j=30;j<=38;j++){
		for( int i=25;i<=47;i++){
			SetPixelV( hDC, i, j, RGB(fastcolor[0],fastcolor[1],fastcolor[2]) );
		}
	}


	PrintCurrentColor();


//	PrintDeltazone();


	{
		int x=deltacursorx;
		int y=deltacursory;
		PrintCursorDelta(x,y);
	}

	PrintCursorCircle();
}
*/




/*****************************************************************************/
Boolean DoParameters (GPtr globals)
{

	INT_PTR			nResult = noErr;
	PlatformData	*platform;
	
	platform = (PlatformData *)((PickerRecordPtr) gStuff)->platformData;

	/* Query the user for parameters. */

	nResult = DialogBoxParam(GetDLLInstance(),
					   (LPSTR)"PICKERPARAM",
					   (HWND)platform->hwnd,
					   (DLGPROC)PickerProc,
						(LPARAM)globals);

	return (nResult == OK); // could be -1
}

// NearestBaseUIWin.cpp